MODULE AUTEX;
(*  2012-2016 Ari.Tao  * 12.10.12 - 11.08.16
                                                                          .
     Beendet die Abarbeitung des \AUTO\ und setzt
      als Boot-Device das 5. Zeichen seines Namens.
      Kann mittels Status-Tasten bergangen werden.
      Weitere Info -> C:\TOS\LOADER\AUT?X\AUT?X.TXT

  Bsp. zur Benutzung:
   AUT-C.PRG im G:\AUTO\ zw. MAGXBOOT.PRG und MINTNP.PRG einfgen, zugleich
   im MAGIC\START\ BDEV-RE.PRG einfgen (damit auch der Warm-Reset funzt).
   Dann kann man mit r+l-Shift MAGX aushngen und zu MiNT wechseln!

  Ist ein bichen ein Hack (weil die Parent-BasePage manipuliert wird, um
  die FileSeek-Liste des GEMDOS zu splen), hat aber dafr die Vorteile, da
  es gar nicht im Speicher bleibt, und keine Fortsetzung im \AUTO\ nach dem
  Auflsungswechsel unter MAGIC mehr! (Und kann von nahezu berall starten!)
  Auf der Strecke blieb (weil nicht gebraucht & strend) die Abarbeitung des
  \AUTO\ 'fern der Heimat' (knnte man aber bei Bedarf leicht nachrsten).

*)(*$T-,$S-,$A+   mit Mini-GEMX linken! *)

IMPORT Main, GDB, GEMX, Aux, BIOX;
FROM   SYSTEM  IMPORT CODE,PUSH;
CONST  XTRAP = 4E4EH; RTS = 4E75H;
VAR    d, BootDev[446H]: CARDINAL;

PROCEDURE SupEx (p: PROC); BEGIN PUSH (p); PUSH (38); CODE(XTRAP) END SupEx;
PROCEDURE bdev; (*$P-*) BEGIN BootDev := d; CODE (RTS) END bdev; (*$P+*)
PROCEDURE getB (VAR me: ARRAY OF CHAR): CARDINAL;
 VAR   k,i, d: CARDINAL;
 BEGIN k := 0; i := 0;
   WHILE (me[i] # 0c) & (i < 248) DO
      IF (me[i] = '\') THEN k := i+1 END; INC (i) END;
   INC (k, 4); d := ORD (CAP (me[k]));
   IF    (d >= ORD ('A')) THEN DEC (d, ORD ('A'));
   ELSIF (d >= ORD ('0')) THEN DEC (d, ORD ('0') - 25) END;
   RETURN d END getB;

PROCEDURE FlushFSofParent;
 VAR   pDTA: POINTER TO GDB.DTA;
       pPar: GEMX.BpPtr;
 BEGIN pPar := GEMX.pBP^.ParentBP;
       pDTA := pPar^.DtaPtr;
       GDB.SetDTA (pDTA);
       REPEAT UNTIL GDB.SNext() # 0;
   END FlushFSofParent;

PROCEDURE BraKey (VAR p: ARRAY OF CHAR): CHAR;
 VAR   b: CHAR;
 BEGIN b := 0c;
       IF BIOX.KBShiftS () # { } THEN
          BIOX.FlushCi;
          BIOX.ConSo (Aux.CRLF);
          BIOX.ConSo (p) END;
   WHILE (BIOX.KBShiftS () # { }) DO
      IF  BIOX.ConIs () THEN BIOX.NecCi (b);
          BIOX.ConCo (' ');  BIOX.ConCo (b); BIOX.ConSo (Aux.CRLF);
          BIOX.FlushCi; END; END (*W*);
   RETURN b; END BraKey;

VAR   me: GDB.PATH; c: CHAR;
BEGIN     c := BraKey (" Skip AUTEX? Type y(es) or else: ");
          IF (CAP (c) = 'Y') THEN RETURN END;
          FlushFSofParent;
   me := "#####################";
   Main.Call (me);
   d := getB (me);
   GDB.SetDrv (d);       (* nutzt nix! *)
   d := d + (d * 100H);
   SupEx (bdev);
   END AUTEX .
